HDU-4255

A Famous Grid

Time Limit: 10000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1496    Accepted Submission(s): 567

Problem Description

Mr. B has recently discovered the grid named "spiral grid".
Construct the grid like the following figure. (The grid is actually infinite. The figure is only a small part of it.)

Considering
traveling in it, you are free to any cell containing a composite number
or 1, but traveling to any cell containing a prime number is
disallowed. You can travel up, down, left or right, but not diagonally.
Write a program to find the length of the shortest path between pairs of
nonprime numbers, or report it‘s impossible.

Input

Each test case is described by a line of input containing two nonprime integer 1 <=x, y<=10,000.

Output

For
each test case, display its case number followed by the length of the
shortest path or "impossible" (without quotes) in one line.

Sample Input

1 4

9 32

10 12

Sample Output

Case 1: 1

Case 2: 7

Case 3: impossible

Source

Fudan Local Programming Contest 2012

/**
          题意:给出两个数,问两点之间的最短距离
          做法:蛇形矩阵 + bfs + 优先队列
**/
#include <iostream>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <string.h>
#include <queue>
#define maxn 40000
using namespace std;
int mmap[200][200];
int a[200][200];
int vis[200][200];
int dx[4] = {0,0,-1,1};
int dy[4] = {1,-1,0,0};
int n,m;
bool num[maxn];
void is_prime()
{
    int tot = 0;
    memset(num,false,sizeof(num));
    num[1] = true;
    for(long long  i=2; i<maxn; i++)
    {
        if(!num[i])
        {
            for(long long j=i*i; j<=maxn; j+=i)
            {
                num[j] = true;
            }
        }
    }
}
struct Node
{
    int x;
    int y;
    int step;
    Node() {}
    Node(int _x,int _y,int _step)
    {
        x = 0;
        y = 0;
        step =0;
    }
} start,endd;
struct cmp
{
    bool operator () (const Node &a,const Node &b)
    {
        return a.step>b.step;
    }
};
int check(int x,int y)
{
    if(x>=0 && x <200 && y >= 0 && y < 200 && num[a[x][y]] == true&& !vis[x][y]) return 1;
    return 0;
}
priority_queue<Node,vector<Node>,cmp >que;
bool bfs()
{
    memset(vis,0,sizeof(vis));
    Node tmp,now;
    while(!que.empty()) que.pop();
    que.push(start);
    vis[start.x][start.y] = 1;
    start.step = 0;
    while(!que.empty())
    {
        now = que.top();
        que.pop();
        //cout<<now.x<<"   "<<now.y<<"   "<<now.step<<endl;
        if(now.x == endd.x && now.y == endd.y)
        {
            endd.step = now.step;
            return true;
        }
        for(int i=0; i<4; i++)
        {
            tmp.x = now.x + dx[i];
            tmp.y = now.y + dy[i];
            tmp.step = now.step + 1;
            if(check(tmp.x,tmp.y))
            {
                vis[tmp.x][tmp.y] = 1;
                que.push(tmp);
            }
        }
    }
    return false;
}
void init()
{
    int x = 0;
    int y = 0;
    int nn = 200;
    int num=a[0][0]=40000;
    while(num>1)
    {
        while((y+1)<nn&&!a[x][y+1])  a[x][++y]= --num;
        while((x+1)<nn&&!a[x+1][y])  a[++x][y]= --num;
        while((y-1)>=0&&!a[x][y-1]) a[x][--y]= --num;
        while((x-1)>=0&&!a[x-1][y]) a[--x][y]= --num;

    }
}
int main()
{
    //freopen("in.txt","r",stdin);
    init();
    is_prime();
    int Case = 1;
    while(~scanf("%d %d",&n,&m))
    {
        for(int i=0; i<200; i++)
        {
            for(int j=0; j<200; j++)
            {
                if(a[i][j] == n)
                {
                    start.x = i;
                    start.y = j;
                }
                if(a[i][j] == m)
                {
                    endd.x= i;
                    endd.y = j;
                }
            }
        }
        bool prime = false;
        prime = bfs();
        printf("Case %d: ",Case++);
        if(prime) printf("%d\n",endd.step);
        else printf("impossible\n");
    }
    return 0;
}
时间: 2024-07-30 06:31:51

HDU-4255的相关文章

hdu 4255 A Famous Grid

题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=4255 A Famous Grid Description Mr. B has recently discovered the grid named "spiral grid".Construct the grid like the following figure. (The grid is actually infinite. The figure is only a small par

hdu 4255 含限制条件的广搜

复旦2012机试题 #include<cstdio> #include<cstring> #include<cmath> #include<queue> #include<algorithm> using namespace std; int g[210][210],vis[210][210]; int dir[4][2]={0,1,-1,0,0,-1,1,0}; int isprime(int n){ for(int i=2;i<=sqr

HDU ACM 4255 A Famous Grid

A Famous Grid Time Limit: 10000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1562    Accepted Submission(s): 603 Problem Description Mr. B has recently discovered the grid named "spiral grid". Construct

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name

hdu 6166 Senior Pan

地址:http://acm.split.hdu.edu.cn/showproblem.php?pid=6166 题目: Senior Pan Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 245    Accepted Submission(s): 71 Problem Description Senior Pan fails i